// NFC [NHN Foundation Class]
//
//
// Copyright (C) 2006, nhn corp
// All rights reserved.

// $Id: Semaphore.cpp,v 1.2 2006/07/29 06:09:22 taekwonv Exp $

#include "Stdafx.h"
#include "NfcSemaphore.h"

using namespace nfc;

#ifndef ASSERT
	#define ASSERT(s)       (void(0))
#endif // ASSERT
#ifndef TRACE
	#define TRACE(s)        (void(0))
#endif // TRACE
#ifndef ABORT
	#define ABORT(s)        (void(0))
#endif // ABORT



#ifdef WIN32

CSemaphore::CSemaphore(long nInitialCount, long nMaximumCount)
{
	m_hSema = ::CreateSemaphore(NULL, nInitialCount, nMaximumCount, NULL);
    ASSERT(m_hSema != NULL);
}

CSemaphore::~CSemaphore()
{
	::CloseHandle(m_hSema);
}

void CSemaphore::Lock()
{
	if (::WaitForSingleObject(m_hSema, INFINITE) != WAIT_OBJECT_0)
    {
        ABORT("CSemaphore::Lock() : failed\n");
    }
}

void CSemaphore::Unlock()
{
	::ReleaseSemaphore(m_hSema, 1, NULL);
}

#endif // #ifdef WIN32


#if defined(__NFC_LINUX__) || defined(__NFC_FREEBSD__)  || defined(__APPLE_CC__) || defined(ANDROID)  
CSemaphore::CSemaphore(long nInitialCount, long nMaximumCount)
{
	
}

CSemaphore::~CSemaphore()
{
	
}

void CSemaphore::Lock()
{
	
}

void CSemaphore::Unlock()
{
	
}
#endif // #if defined(__NFC_LINUX__) || defined(__NFC_FREEBSD__)    
